;Example POOL program, you may use it,
;modify and distribute under GPL license.
;Authors: R&D Independent Team
;Source: www.pool-rnd.com

to bubble :r :mass [:loss 0.008]
  local [d w g]
  to force :xy
    :xy,1 -= xcor
    :xy,2 -= ycor
    "d := sqrt :xy,1^2 + :xy,2^2
    "w := (:d / :r)^2
    "g := 0.5 * (0.5 - (1.5 / exp :w^3)) / (-0.5 * (:w + 1) * :d)
    :xy,1 *= :g
    :xy,2 *= :g
    op :xy
  end

  to fdraw :x :y
    let "d2 (:x - xcor)^2 + (:y - ycor)^2
    let "c 100 * :d2 / :r^2
    if :c > 100 ["c := (100 - 75 * ((sqrt :d2) - :r))]
    if :c < 0 ["c := 0]
    op (array 0 0 0 0.5 * :c)
  end

  to draw :a (render $fdraw :a :p0 :p1) end

  to sum_forces
    let "f newarray 2
    foreach "t :fb [
      if :t <> this [
        let "g force pos @ :t
        :f,1 += :g,1
        :f,2 += :g,2
      ]
    ]
    output :f
  end

  let "speed 0
  to onsignalstep :turtle :data
    let "dt :data,2
    ifelse :dt < 80 ["dt := 0.01 * :dt] ["dt := 0.8]
    let "f sum_forces
    lock "speed [
      let "mdir movedir
      :mdir,1 := :mdir,1 * :speed + :f,1 * :dt / :mass
      :mdir,2 := :mdir,2 * :speed + :f,2 * :dt / :mass
      "speed := sqrt (:mdir,1)^2 + (:mdir,2)^2
      if :speed > 50 ["speed := 50]
      setmovedir :mdir alignh
      let "ds :speed * :dt
      "speed -= :loss * :ds
      if :speed < 0 ["speed := 0]
    ]
    fd :ds
  end

  ht
  let "p0 array (xcor - :r - 4) (ycor + :r + 4)
  let "p1 array (xcor + :r + 4) (ycor - :r - 4)
  draw 60
  let "img image :p0 :p1
  clean

  (setti :img :img 1)
  setr :r
end

ht pu bounce
shared "fb
"fb := newarray 50
repeat count :fb [
  let "r (rnorm 40 30)
  if :r < 10 ["r := 10]
  if :r > 100 ["r := 100]
  :fb,repcount := (newt $bubble :r :r / 30)
]

setbg {90 87 95}

foreach "i :fb [
  (setxy rnorm 100 rnorm 100) @ :i
  st @ :i
]

"t := timer "step 21


